;*****************************************************************;
;*****************************************************************;
;**								**;
;**	(C)Copyright 1985-1995, American Megatrends Inc.	**;
;**								**;
;**			All Rights Reserved.			**;
;**								**;
;**		6145-F, Northbelt Parkway, Norcross,		**;
;**								**;
;**		Georgia - 30071, USA. Phone-(770)-263-8181.	**;
;**								**;
;*****************************************************************;
;*****************************************************************;
	page	55,130
	title	FLASH PROGRAMMING UTILITY..MAIN PROGRAM
	subttl	AMIFLASH.ASM	012192	022092	05:00pm
	.286p
;---------------------------------------;
;  FLASH EPROM PROGRAMMING UTILITY	;
;  MAIN PROGRAM				;
;---------------------------------------;
cgroup	group	cseg
cseg	segment	word	public	'CODE'
	assume	cs:cgroup, ds:nothing, es:nothing, ss:nothing
;---------------------------------------;
	include	flash.equ		; equates
	include	flash.mac		; macro
;---------------------------------------;
;	EXTERNAL DEFINITIONS		;
;---------------------------------------;
	extrn	help_back_attr:byte
	extrn	help_input_fore_attr:byte
	extrn	flash_type:byte
	extrn	press_any_key_msg:byte
	extrn	flash_detect_table:word
	extrn	memory_allocation_err_msg:byte
	extrn	pmode_err_msg:byte
	extrn	sign_on:byte

	extrn	detect_cpu_type:near
	extrn	display_string_dx:near
	extrn	wait_for_key:near
	extrn	init_config_data:near
	extrn	save_environment_init:near
	extrn	restore_environment:near
	extrn	display_sign_on:near
	extrn	allocate_initial_memory:near
	extrn	get_save_read_bios_file:near
	extrn	display_help_error:near
	extrn	erase_disp_exit_msg:near
	extrn	restore_chipset_environment:near
	extrn	enable_flash_select:near
	extrn	disable_flash_select:near
	extrn	save_internal_cache:near
	extrn	disable_internal_cache:near
	extrn	restore_internal_cache:near
	extrn	get_cursor_posn:near
	extrn	display_string_dx:near
	extrn	check_flash_bios:near
;---------------------------------------;
;	PUBLIC DEFINITIONS		;
;---------------------------------------;
	public	main_exit

	public	stack_end
;---------------------------------------;
;	MAIN PROGRAM			;
;---------------------------------------;
	ORG	100H			; .COM program
flash_suru:
	jmp	main
	even
	dw	512 dup (00)		; stack
stack_end	label	word
org_ss		dw	0000h		; saves SS of invoking process
org_sp		dw	0000h		; saves SP of invoking process
;---------------------------------------;
main	proc	near
	cli				; disable interrupt
	cld				; clear direction flag
	check_point	01h		; ======== 01
;  segment registers setting..
	mov	cgroup:org_ss,ss	; save orginal SS,SP..may be needed
	mov	cgroup:org_sp,sp	; to return to DOS in case of error..
	mov	ax,cs
	mov	ds,ax			; DS = CS
	mov	es,ax			; ES = CS
	mov	ss,ax			; SS = CS
	mov	sp,offset cgroup:stack_end; set SP
	sti				; enable interrupt
	mov	si,offset cgroup:pmode_err_msg
	smsw	ax
	test	al,01h			; in protected mode ?
	jz	main_06			; no
	push	si
	push	ds
	push	0040h
	pop	ds
	mov	al,ds:byte ptr [curr_vdo_mode]; set vdo mode
	pop	ds
	mov	ah,00h
	int	10h
	call	get_cursor_posn		; get cursor posn
	mov	bl,normal_attribute
	mov	si,offset cgroup:sign_on
	call	display_string_dx
	mov	ax,0e0dh
	int	10h
	mov	ax,0e0ah
	int	10h
	call	get_cursor_posn		; get cursor posn
	pop	si
	call	display_string_dx
	jmp	main_exit_01		; error in shrinking memory
main_06:
	check_point	05h		; ======== 05
;  initialise data areas e.g. set the attributes of different windows, etc..
;  get the vdo information and save the current status of vdo..
	call	save_environment_init	; save current environment and init
					; data areas
;  determine cpu type..
	check_point	06h		; ======== 06
	call	detect_cpu_type		; detect cpu type 286/386/486
;  initialise the configurable data areas..
	check_point	07h		; ======== 07
	call	init_config_data	; init configurable data areas
	check_point	09h		; ======== 09
;  show up the initial screen..
	call	display_sign_on		; display sign-on screen
	check_point	0dh		; ======== 0D
	call	check_flash_bios	; check for flash bios presence
	jnc	main_100		; ok
main_error:
;  SI = ptr to error string..
	call	display_help_error	; display error..
	call	erase_disp_exit_msg	; erase "Press <ESC> to EXIT" and
					; display "Press any key to Exit" and
					; wait for key pressing
	jmp	short main_exit_00
main_100:
;  allocate the memory blocks..
	call	allocate_initial_memory	; allocate memory block needed initially
	mov	si,offset cgroup:memory_allocation_err_msg
	jc	main_error		; error..
main_05:
;  get the BIOS filename from user and read it into the buffer..
;  and program the flash..
	check_point	24h		; ======== 24
	call	get_save_read_bios_file	; get and read bios file
main_exit::
main_exit_00:
	check_point	36h		; ======== 36
	call	restore_environment	; restore original environment
main_exit_01:
	cli				; disable interrupt
	mov	ss,cgroup:org_ss	; restore original SS, SP
	mov	sp,cgroup:org_sp
	sti				; enable interrupt
	mov	ax,4c00h		; AH = func# 4Ch..AL = 00..return code
	int	21h			; terminate current process and return
					; to invoking process
main	endp
;---------------------------------------;
cseg	ends
end	flash_suru
;*****************************************************************;
;*****************************************************************;
;**								**;
;**	(C)Copyright 1985-1995, American Megatrends Inc.	**;
;**								**;
;**			All Rights Reserved.			**;
;**								**;
;**		6145-F, Northbelt Parkway, Norcross,		**;
;**								**;
;**		Georgia - 30071, USA. Phone-(770)-263-8181.	**;
;**								**;
;*****************************************************************;
;*****************************************************************;

